<template>
  <section class="pt-5">
    <div class="container">
      <div class="row pt-5">
        <h1>Tas Belanja</h1>
        <div class="col">
          <table class="table table-striped table-borderless">
            <thead>
              <tr>
                <th scope="col"></th>
                <th scope="col">Judul</th>
                <th scope="col">Author</th>
                <th scope="col">Harga</th>
                <th scope="col">Jumlah</th>
                <th scope="col">Total</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(buku, index) in bukus" :key="index">
                <th scope="row" class="p-3 frame">
                  <img :src="buku.cover" class="card-img-top pb-3" style="
                      max-width: 100%;
                      max-height: 100%;
                      object-fit: cover;
                      object-position: center;
                    " alt="" />
                </th>
                <td class="p-3 text-wrap w-25">{{ buku.title }}</td>
                <td class="p-3 text-wrap w-25">{{ buku.author }}</td>
                <td class="p-3">Rp{{ buku.price }}</td>
                <td class="p-3" style="width: 20%;">
                  <div class="input-group input-group-sm">
                    <input type="text" class="form-control form-control-sm text-center" v-model="buku.quantity" />
                    <button class="btn btn-primary mx-1" type="button" @click="decrementQuantity(buku, index)">
                      -
                    </button>
                    <button class="btn btn-primary" type="button" @click="incrementQuantity(buku, index)">
                      +
                    </button>
                  </div>
                  <div class="input-group input-group-sm d-flex flex-column justify-content-center mt-2">
                    <button class="btn btn-sm btn-danger" @click="deleteRow(index, buku.buku_id)">
                      Delete
                    </button>
                  </div>
                </td>
                <td class="p-3">{{ calculateTotal(buku) }}</td>
              </tr>
            </tbody>
          </table>
        </div>
        <div class="col-sm-6 w-25">
          <div class="card border-0" style="background-color: #f1f1f1">
            <div class="card-body d-flex flex-column">
              <h5 class="card-title">Ringkasan Belanja</h5>
              <div class="d-flex justify-content-between my-3">
                <p class="card-text">Total Pembayaran</p>
                <p class="card-text">Rp{{ calculateGrandTotal() }}</p>
              </div>
              <router-link :to="{ name: 'pages.Order', params: { source: 'cart' } }" class="btn btn-primary" style="margin-top: auto">Beli
                Sekarang</router-link>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import { ref, onMounted } from "vue";
import axios from "axios";

export default {
  setup() {
    // Reactive state
    const bukus = ref([]);
    const userId = ref(null);
    const qty = ref(1);


    const fetchCartData = () => {
      axios
        .get(`http://localhost:8000/api/keranjang?user_id=${userId.value}`)
        .then((response) => {
          const cartData = response.data.data;
          console.log(cartData);

          // Buat array promise untuk mendapatkan detail buku
          const bookPromises = cartData.map((cartItem) => {
            return axios
              .get(`http://localhost:8000/api/buku/${cartItem.buku_id}`)
              .then((bookResponse) => {
                const book = bookResponse.data.bukus;
                console.log(bookResponse.data);

                return {
                  id: cartItem.id,
                  buku_id: cartItem.buku_id, // Add buku_id for later use
                  title: book.title,
                  author: book.author,
                  price: book.price,
                  quantity: cartItem.qty,
                  cover: book.cover,
                };
              })
              .catch((error) => {
                console.log("Error fetching book details:", error);
                return null;
              });
          });

          // Jalankan semua promise secara bersamaan
          Promise.all(bookPromises).then((bookDetails) => {
            // Filter nilai null jika ada yang gagal
            const validBookDetails = bookDetails.filter(
              (book) => book !== null
            );
            // Tambahkan semua detail buku ke dalam bukus state
            bukus.value = validBookDetails;
          });
        })
        .catch((error) => {
          console.log("Error fetching cart data:", error);
        });
    };

    // Fetch cart data when component is mounted
    onMounted(() => {
      // Get userId from state or local storage after user login
      userId.value = 1;

      // Fetch cart data for the user
      fetchCartData();
    });

    const incrementQuantity = (buku, index) => {
      buku.quantity++;
      qty.value = 1;
      updateCartQuantity(userId.value, buku.buku_id, qty.value, index);
    };

    const decrementQuantity = (buku, index) => {
      if (buku.quantity > 1) {
        buku.quantity--;
        qty.value = -1;
        updateCartQuantity(userId.value, buku.buku_id, qty.value, index);
      }
    };

    const updateCartQuantity = (user_id, buku_id, qty, index) => {
      console.log("update clicked");
      axios
        .put(`http://localhost:8000/api/keranjang/${buku_id}`, {
          user_id: user_id,
          buku_id: buku_id,
          qty: qty,
        })
        .then((response) => {
          console.log("Quantity updated successfully");
        })
        .catch((error) => {
          console.error("Error updating quantity:", error);
        });
    };

    const deleteRow = (index, buku_id) => {
      axios
        .delete(`http://localhost:8000/api/keranjang/${buku_id}`, {
          data: {
            user_id: userId.value,
            buku_id: buku_id,
          },
        })
        .then((response) => {
          console.log("Item deleted successfully");
          bukus.value.splice(index, 1);
        })
        .catch((error) => {
          console.error("Error deleting item:", error);
        });
    };

    const calculateTotal = (buku) => {
      return buku.price * buku.quantity;
    };

    const calculateGrandTotal = () => {
      let grandTotal = 0;
      for (let buku of bukus.value) {
        grandTotal += calculateTotal(buku);
      }
      return grandTotal;
    };

    return {
      bukus,
      incrementQuantity,
      decrementQuantity,
      calculateTotal,
      calculateGrandTotal,
      deleteRow,
    };
  },
};
</script>
